<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();


if ( 
    // !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}


function getSpecificPrintSettings($conn_rjllearning_specific,$institution_id,$branch_id) {
    
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM  print_settings where institution_id =? AND branch_id = ?");
    $sql->execute(array($institution_id,$branch_id));
    $result = $sql->fetchAll();
    // print_R($result);die();
    if (count($result) >= 1) {
        $printh_info = array();
        foreach($result as $rows){
        $branch_info[] = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        
        $printh_info[] =  array('print_id'=> $rows['id'],'institution_id'=> $rows['institution_id'],'branch_id'=> $branch_info,'primary_color'=> $rows['primary_color']
        ,'secondary_color'=> $rows['secondary_color'],'id_card_template_selected'=> $rows['id_card_template_selected']);
        }
        return $printh_info;
    }
    
    // else{
    //       errorreturn("Print settings not found.");
    // }

}

if($postdata['function_type']  == "print_settings") {  
    
    // $branch_id = trim($postdata['branch_id']);
    // $institution_id = trim($postdata['institution_id']);    
    $success['data'] = getSpecificPrintSettings($conn_rjllearning_specific,$institution_id,$branch_id);
    successreturn($success);
      
}

